package com.dermandar.panoramal;

import android.graphics.Bitmap;
import android.graphics.Color;

import java.nio.ByteBuffer;

/**
 * Created by AMS on 10/25/2017.
 */

public class DMDBitmapToRGBA888 {

    private static int[] GetPixels(Bitmap bmp)
    {
        int height = bmp.getHeight();
        int width = bmp.getWidth();
        int length = width * height;
        int[] pixels = new int[length];
        bmp.getPixels(pixels, 0, width, 0, 0, width, height);
        for(int i=0; i<pixels.length; i++)
            pixels[i]= (Color.red(pixels[i]) << 24) | (Color.green(pixels[i]) << 16) | (Color.blue(pixels[i])<<8) | Color.alpha(pixels[i]);
        return pixels;
    }

    public static byte[] ImageToRGBA8888(Bitmap bmp) {

        if (bmp == null) return null;

        byte[] bytes = new byte[bmp.getAllocationByteCount()];
        ByteBuffer bb = ByteBuffer.wrap(bytes);
        bb.asIntBuffer().put(DMDBitmapToRGBA888.GetPixels(bmp));
        return bytes;
    }
}
